QGIS Application - Bug report #15218
MSSQL columns with default values not ignored
2016-07-04 06:29 PM - Damien Smith

Status: Closed

Priority: Normal

Assignee: Tamas Szekeres

Category: Data Provider/MSSQL

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 23155
Description

Many MSSQL tables use unique identifiers (UUID) for columns. These often have a default value such as newid(). QGIS currently
attempts to overwrite these values when saving which results in an error.

QGIS needs to completely ignore MSSQL columns that have a default value when doing updates and inserts. Setting the fields to
"Hidden" works for inserts but then fails for updates.

History

#1 - 2016-07-07 09:24 PM - Damien Smith

Actually, setting to "Hidden" or "Text" (Not editable) allows inserting and updating but copying and pasting fails if there is a unique constraint because the
UUID is duplicated rather than using the default newid() function.

So, the only way to fix this is to reset fields which have a default value to their default value when copying and pasting. Also, using a view is not an option

for large MSSQL tables as QGIS does a full table extents scan on views as it's not aware of the spatial index on the base table.

#2 - 2016-07-21 03:50 PM - Damien Smith

If the UUID has a unique constraint, splitting the geometry also causes a duplicate but the original is committed to the database when saving causing lost

geometry.

#3 - 2017-05-01 01:05 AM - Giovanni Manghi
- Easy fix? set to No

- Regression? set to No

#4 - 2017-09-22 09:55 AM - Jiirgen Fischer
- Category set to Unknown

#5 - 2018-02-13 12:25 AM - Nathan Woodrow
- Description updated

Damien can you check if this is still the case in 3. | have a feeling | have already fixed it.

#6 - 2018-10-02 10:16 PM - Nyall Dawson
- Category changed from Unknown to Data Provider/MSSQL
#7 - 2018-10-02 10:17 PM - Nyall Dawson
- Status changed from Open to Closed

Closed due to lack of feedback

#8 - 2018-10-03 12:12 AM - Damien Smith

Confirmed issue has been fixed in QGIS 3.
